Index: vm/vm_map.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_map.c,v
retrieving revision 1.21
diff -u -r1.21 vm_map.c
--- vm/vm_map.c	20 Jan 2004 18:41:52 -0000	1.21
+++ vm/vm_map.c	23 Feb 2004 03:37:19 -0000
@@ -330,6 +330,22 @@
 }
 
 /*
+ *      vm_map_entry_cpu_init:
+ *
+ *	Set an initial negative count so the first attempt to reserve
+ *	space preloads a bunch of vm_map_entry's for this cpu.  This
+ *	routine is called in early boot so we cannot just call
+ *	vm_map_entry_reserve().
+ *
+ *	May be called for a gd other then mycpu.
+ */
+void
+vm_map_entry_reserve_cpu_init(globaldata_t gd)
+{
+	gd->gd_vme_avail -= MAP_RESERVE_COUNT * 2;
+}
+
+/*
  *	vm_map_entry_reserve:
  *
  *	Reserves vm_map_entry structures so code later on can manipulate
@@ -2188,14 +2204,15 @@
 			int flags;
 
 			vm_object_reference(object);
-			vn_lock(object->handle, LK_EXCLUSIVE | LK_RETRY, curthread);
+			vn_lock(object->handle, NULL,
+				LK_EXCLUSIVE | LK_RETRY, curthread);
 			flags = (syncio || invalidate) ? OBJPC_SYNC : 0;
 			flags |= invalidate ? OBJPC_INVAL : 0;
 			vm_object_page_clean(object,
 			    OFF_TO_IDX(offset),
 			    OFF_TO_IDX(offset + size + PAGE_MASK),
 			    flags);
-			VOP_UNLOCK(object->handle, 0, curthread);
+			VOP_UNLOCK(object->handle, NULL, 0, curthread);
 			vm_object_deallocate(object);
 		}
 		if (object && invalidate &&
Index: vm/vm_map.h
===================================================================
RCS file: /cvs/src/sys/vm/vm_map.h,v
retrieving revision 1.11
diff -u -r1.11 vm_map.h
--- vm/vm_map.h	20 Jan 2004 18:41:52 -0000	1.11
+++ vm/vm_map.h	23 Feb 2004 01:20:28 -0000
@@ -257,20 +257,13 @@
  *		as unbraced elements in a higher level statement.
  */
 
-#define	vm_map_lock_drain_interlock(map) \
-	do { \
-		lockmgr(&(map)->lock, LK_DRAIN|LK_INTERLOCK, \
-			&(map)->ref_lock, curthread); \
-		(map)->timestamp++; \
-	} while(0)
-
 #ifdef DIAGNOSTIC
 /* #define MAP_LOCK_DIAGNOSTIC 1 */
 #ifdef MAP_LOCK_DIAGNOSTIC
 #define	vm_map_lock(map) \
 	do { \
 		printf ("locking map LK_EXCLUSIVE: 0x%x\n", map); \
-		if (lockmgr(&(map)->lock, LK_EXCLUSIVE, (void *)0, curthread) != 0) { \
+		if (lockmgr(&(map)->lock, LK_EXCLUSIVE, NULL, curthread) != 0) { \
 			panic("vm_map_lock: failed to get lock"); \
 		} \
 		(map)->timestamp++; \
@@ -278,7 +271,7 @@
 #else
 #define	vm_map_lock(map) \
 	do { \
-		if (lockmgr(&(map)->lock, LK_EXCLUSIVE, (void *)0, curthread) != 0) { \
+		if (lockmgr(&(map)->lock, LK_EXCLUSIVE, NULL, curthread) != 0) { \
 			panic("vm_map_lock: failed to get lock"); \
 		} \
 		(map)->timestamp++; \
@@ -287,7 +280,7 @@
 #else
 #define	vm_map_lock(map) \
 	do { \
-		lockmgr(&(map)->lock, LK_EXCLUSIVE, (void *)0, curthread); \
+		lockmgr(&(map)->lock, LK_EXCLUSIVE, NULL, curthread); \
 		(map)->timestamp++; \
 	} while(0)
 #endif /* DIAGNOSTIC */
@@ -296,25 +289,25 @@
 #define	vm_map_unlock(map) \
 	do { \
 		printf ("locking map LK_RELEASE: 0x%x\n", map); \
-		lockmgr(&(map)->lock, LK_RELEASE, (void *)0, curthread); \
+		lockmgr(&(map)->lock, LK_RELEASE, NULL, curthread); \
 	} while (0)
 #define	vm_map_lock_read(map) \
 	do { \
 		printf ("locking map LK_SHARED: 0x%x\n", map); \
-		lockmgr(&(map)->lock, LK_SHARED, (void *)0, curthread); \
+		lockmgr(&(map)->lock, LK_SHARED, NULL, curthread); \
 	} while (0)
 #define	vm_map_unlock_read(map) \
 	do { \
 		printf ("locking map LK_RELEASE: 0x%x\n", map); \
-		lockmgr(&(map)->lock, LK_RELEASE, (void *)0, curthread); \
+		lockmgr(&(map)->lock, LK_RELEASE, NULL, curthread); \
 	} while (0)
 #else
 #define	vm_map_unlock(map) \
-	lockmgr(&(map)->lock, LK_RELEASE, (void *)0, curthread)
+	lockmgr(&(map)->lock, LK_RELEASE, NULL, curthread)
 #define	vm_map_lock_read(map) \
-	lockmgr(&(map)->lock, LK_SHARED, (void *)0, curthread) 
+	lockmgr(&(map)->lock, LK_SHARED, NULL, curthread) 
 #define	vm_map_unlock_read(map) \
-	lockmgr(&(map)->lock, LK_RELEASE, (void *)0, curthread)
+	lockmgr(&(map)->lock, LK_RELEASE, NULL, curthread)
 #endif
 
 static __inline__ int
@@ -323,7 +316,7 @@
 #if defined(MAP_LOCK_DIAGNOSTIC)
 	printf("locking map LK_EXCLUPGRADE: 0x%x\n", map); 
 #endif
-	error = lockmgr(&map->lock, LK_EXCLUPGRADE, (void *)0, td);
+	error = lockmgr(&map->lock, LK_EXCLUPGRADE, NULL, td);
 	if (error == 0)
 		map->timestamp++;
 	return error;
@@ -335,24 +328,26 @@
 #define vm_map_lock_downgrade(map) \
 	do { \
 		printf ("locking map LK_DOWNGRADE: 0x%x\n", map); \
-		lockmgr(&(map)->lock, LK_DOWNGRADE, (void *)0, curthread); \
+		lockmgr(&(map)->lock, LK_DOWNGRADE, NULL, curthread); \
 	} while (0)
 #else
 #define vm_map_lock_downgrade(map) \
-	lockmgr(&(map)->lock, LK_DOWNGRADE, (void *)0, curthread)
+	lockmgr(&(map)->lock, LK_DOWNGRADE, NULL, curthread)
 #endif
 
 #define vm_map_set_recursive(map) \
 	do { \
-		lwkt_gettoken(&(map)->lock.lk_interlock); \
+		lwkt_tokref ilock; \
+		lwkt_gettoken(&ilock, &(map)->lock.lk_interlock); \
 		(map)->lock.lk_flags |= LK_CANRECURSE; \
-		lwkt_reltoken(&(map)->lock.lk_interlock); \
+		lwkt_reltoken(&ilock); \
 	} while(0)
 #define vm_map_clear_recursive(map) \
 	do { \
-		lwkt_gettoken(&(map)->lock.lk_interlock); \
+		lwkt_tokref ilock; \
+		lwkt_gettoken(&ilock, &(map)->lock.lk_interlock); \
 		(map)->lock.lk_flags &= ~LK_CANRECURSE; \
-		lwkt_reltoken(&(map)->lock.lk_interlock); \
+		lwkt_reltoken(&ilock); \
 	} while(0)
 
 /*
@@ -406,6 +401,8 @@
 #ifdef _KERNEL
 boolean_t vm_map_check_protection (vm_map_t, vm_offset_t, vm_offset_t, vm_prot_t);
 struct pmap;
+struct globaldata;
+void vm_map_entry_reserve_cpu_init(struct globaldata *gd);
 int vm_map_entry_reserve(int);
 int vm_map_entry_kreserve(int);
 void vm_map_entry_release(int);
Index: vm/vm_object.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_object.c,v
retrieving revision 1.12
diff -u -r1.12 vm_object.c
--- vm/vm_object.c	11 Nov 2003 01:35:36 -0000	1.12
+++ vm/vm_object.c	22 Feb 2004 19:08:01 -0000
@@ -200,7 +200,7 @@
 vm_object_init()
 {
 	TAILQ_INIT(&vm_object_list);
-	lwkt_inittoken(&vm_object_list_token);
+	lwkt_token_init(&vm_object_list_token);
 	vm_object_count = 0;
 	
 	kernel_object = &kernel_object_store;
@@ -263,7 +263,8 @@
 
 	object->ref_count++;
 	if (object->type == OBJT_VNODE) {
-		while (vget((struct vnode *) object->handle, LK_RETRY|LK_NOOBJ, curthread)) {
+		while (vget((struct vnode *) object->handle, NULL,
+		    LK_RETRY|LK_NOOBJ, curthread)) {
 			printf("vm_object_reference: delay in getting object\n");
 		}
 	}
@@ -412,6 +413,7 @@
 vm_object_terminate(object)
 	vm_object_t object;
 {
+	lwkt_tokref ilock;
 	vm_page_t p;
 	int s;
 
@@ -486,9 +488,9 @@
 	/*
 	 * Remove the object from the global object list.
 	 */
-	lwkt_gettoken(&vm_object_list_token);
+	lwkt_gettoken(&ilock, &vm_object_list_token);
 	TAILQ_REMOVE(&vm_object_list, object, object_list);
-	lwkt_reltoken(&vm_object_list_token);
+	lwkt_reltoken(&ilock);
 
 	wakeup(object);
 
@@ -528,6 +530,7 @@
 	int clearobjflags;
 	int pagerflags;
 	int curgeneration;
+	lwkt_tokref vlock;
 
 	if (object->type != OBJT_VNODE ||
 		(object->flags & OBJ_MIGHTBEDIRTY) == 0)
@@ -644,9 +647,9 @@
                 if (object->type == OBJT_VNODE &&
                     (vp = (struct vnode *)object->handle) != NULL) {
                         if (vp->v_flag & VOBJDIRTY) {
-                                lwkt_gettoken(&vp->v_interlock);
+                                lwkt_gettoken(&vlock, vp->v_interlock);
                                 vp->v_flag &= ~VOBJDIRTY;
-                                lwkt_reltoken(&vp->v_interlock);
+                                lwkt_reltoken(&vlock);
                         }
                 }
 	}
@@ -1705,14 +1708,15 @@
 vm_object_set_writeable_dirty(vm_object_t object)
 {
 	struct vnode *vp;
+	lwkt_tokref vlock;
 
 	vm_object_set_flag(object, OBJ_WRITEABLE|OBJ_MIGHTBEDIRTY);
 	if (object->type == OBJT_VNODE &&
 	    (vp = (struct vnode *)object->handle) != NULL) {
 		if ((vp->v_flag & VOBJDIRTY) == 0) {
-			lwkt_gettoken(&vp->v_interlock);
+			lwkt_gettoken(&vlock, vp->v_interlock);
 			vp->v_flag |= VOBJDIRTY;
-			lwkt_reltoken(&vp->v_interlock);
+			lwkt_reltoken(&vlock);
 		}
 	}
 }
Index: vm/vm_pageout.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_pageout.c,v
retrieving revision 1.8
diff -u -r1.8 vm_pageout.c
--- vm/vm_pageout.c	20 Aug 2003 08:03:01 -0000	1.8
+++ vm/vm_pageout.c	22 Feb 2004 06:17:46 -0000
@@ -546,7 +546,7 @@
 	vm_object_t obj, bigobj;
 	int nothingwired;
 
-	if (lockmgr(&map->lock, LK_EXCLUSIVE | LK_NOWAIT, (void *)0, curthread)) {
+	if (lockmgr(&map->lock, LK_EXCLUSIVE | LK_NOWAIT, NULL, curthread)) {
 		return;
 	}
 
@@ -768,28 +768,37 @@
 		 * the page being dirty, we have to check for it again.  As 
 		 * far as the VM code knows, any partially dirty pages are 
 		 * fully dirty.
+		 *
+		 * Pages marked PG_WRITEABLE may be mapped into the user
+		 * address space of a process running on another cpu.  A
+		 * user process (without holding the MP lock) running on
+		 * another cpu may be able to touch the page while we are
+		 * trying to remove it.  To prevent this from occuring we
+		 * must call pmap_remove_all() or otherwise make the page
+		 * read-only.  If the race occured pmap_remove_all() is
+		 * responsible for setting m->dirty.
 		 */
 		if (m->dirty == 0) {
 			vm_page_test_dirty(m);
+#if 0
+			if (m->dirty == 0 && (m->flags & PG_WRITEABLE) != 0)
+				pmap_remove_all(m);
+#endif
 		} else {
 			vm_page_dirty(m);
 		}
 
-		/*
-		 * Invalid pages can be easily freed
-		 */
 		if (m->valid == 0) {
+			/*
+			 * Invalid pages can be easily freed
+			 */
 			vm_pageout_page_free(m);
 			mycpu->gd_cnt.v_dfree++;
 			--page_shortage;
-
-		/*
-		 * Clean pages can be placed onto the cache queue.  This
-		 * effectively frees them.
-		 */
 		} else if (m->dirty == 0) {
 			/*
-			 * Clean pages can be immediately freed to the cache.
+			 * Clean pages can be placed onto the cache queue.
+			 * This effectively frees them.
 			 */
 			vm_page_cache(m);
 			--page_shortage;
@@ -868,7 +877,7 @@
 			if (object->type == OBJT_VNODE) {
 				vp = object->handle;
 
-				if (vget(vp, LK_EXCLUSIVE|LK_NOOBJ|LK_TIMELOCK, curthread)) {
+				if (vget(vp, NULL, LK_EXCLUSIVE|LK_NOOBJ|LK_TIMELOCK, curthread)) {
 					++pageout_lock_miss;
 					if (object->flags & OBJ_MIGHTBEDIRTY)
 						    vnodes_skipped++;
Index: vm/vm_swap.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_swap.c,v
retrieving revision 1.9
diff -u -r1.9 vm_swap.c
--- vm/vm_swap.c	23 Sep 2003 05:03:54 -0000	1.9
+++ vm/vm_swap.c	22 Feb 2004 06:02:45 -0000
@@ -264,9 +264,9 @@
 	}
 	return EINVAL;
     found:
-	(void) vn_lock(vp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(vp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_OPEN(vp, FREAD | FWRITE, cred, td);
-	(void) VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	if (error)
 		return (error);
 
Index: vm/vm_zone.c
===================================================================
RCS file: /cvs/src/sys/vm/vm_zone.c,v
retrieving revision 1.13
diff -u -r1.13 vm_zone.c
--- vm/vm_zone.c	20 Jan 2004 05:04:08 -0000	1.13
+++ vm/vm_zone.c	22 Feb 2004 07:20:32 -0000
@@ -51,12 +51,13 @@
 zalloc(vm_zone_t z)
 {
 	void *item;
+	lwkt_tokref ilock;
 
 #ifdef INVARIANTS
 	if (z == NULL)
 		zerror(ZONE_ERROR_INVALID);
 #endif
-	lwkt_gettoken(&z->zlock);
+	lwkt_gettoken(&ilock, &z->zlock);
 	if (z->zfreecnt <= z->zfreemin) {
 		item = zget(z);
 		/*
@@ -77,7 +78,7 @@
 		z->zfreecnt--;
 		z->znalloc++;
 	}
-	lwkt_reltoken(&z->zlock);
+	lwkt_reltoken(&ilock);
 	return item;
 }
 
@@ -88,7 +89,9 @@
 void
 zfree(vm_zone_t z, void *item)
 {
-	lwkt_gettoken(&z->zlock);
+	lwkt_tokref ilock;
+
+	lwkt_gettoken(&ilock, &z->zlock);
 	((void **) item)[0] = z->zitems;
 #ifdef INVARIANTS
 	if (((void **) item)[1] == (void *) ZENTRY_FREE)
@@ -97,7 +100,7 @@
 #endif
 	z->zitems = item;
 	z->zfreecnt++;
-	lwkt_reltoken(&z->zlock);
+	lwkt_reltoken(&ilock);
 }
 
 /*
@@ -151,7 +154,7 @@
 
 	if ((z->zflags & ZONE_BOOT) == 0) {
 		z->zsize = (size + ZONE_ROUNDING - 1) & ~(ZONE_ROUNDING - 1);
-		lwkt_inittoken(&z->zlock);
+		lwkt_token_init(&z->zlock);
 		z->zfreecnt = 0;
 		z->ztotal = 0;
 		z->zmax = 0;
@@ -256,7 +259,7 @@
 	z->zpagecount = 0;
 	z->zalloc = 0;
 	z->znalloc = 0;
-	lwkt_inittoken(&z->zlock);
+	lwkt_token_init(&z->zlock);
 
 	bzero(item, nitems * z->zsize);
 	z->zitems = NULL;
@@ -314,9 +317,9 @@
 
 			m = vm_page_alloc(z->zobj, z->zpagecount,
 					  z->zallocflag);
+			/* note: z might be modified due to blocking */
 			if (m == NULL)
 				break;
-			lwkt_regettoken(&z->zlock);
 
 			zkva = z->zkva + z->zpagecount * PAGE_SIZE;
 			pmap_kenter(zkva, VM_PAGE_TO_PHYS(m)); /* YYY */
@@ -331,7 +334,7 @@
 
 		{
 			item = (void *)kmem_alloc3(kernel_map, nbytes, KM_KRESERVE);
-			lwkt_regettoken(&z->zlock);
+			/* note: z might be modified due to blocking */
 			if (item != NULL)
 				zone_kern_pages += z->zalloc;
 		}
Index: vm/vnode_pager.c
===================================================================
RCS file: /cvs/src/sys/vm/vnode_pager.c,v
retrieving revision 1.10
diff -u -r1.10 vnode_pager.c
--- vm/vnode_pager.c	20 Aug 2003 08:03:01 -0000	1.10
+++ vm/vnode_pager.c	22 Feb 2004 06:17:57 -0000
@@ -1050,7 +1050,7 @@
 		if (object->flags & OBJ_DEAD)
 			return NULL;
 
-		while (vget(object->handle,
+		while (vget(object->handle, NULL,
 			LK_NOPAUSE | LK_SHARED | LK_RETRY | LK_CANRECURSE, td)) {
 			if ((object->flags & OBJ_DEAD) ||
 			    (object->type != OBJT_VNODE)) {
